/*
* SACD Decoder plugin
* Copyright (c) 2011 Maxim V.Anisiutkin <maxim.anisiutkin@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#ifndef _SACD_READER_H_INCLUDED
#define _SACD_READER_H_INCLUDED

#include <stdint.h>
#include <foobar2000.h>

class sacd_reader_t {
public:
	sacd_reader_t() {
	}
	virtual ~sacd_reader_t() {
	}
	virtual bool open(service_ptr_t<file> p_file) = 0;
	virtual bool close() = 0;
	virtual int get_channels() = 0;
	virtual int get_samplerate() = 0;
	virtual uint64_t get_size() = 0;
	virtual uint64_t get_offset() = 0;
	virtual double get_duration() = 0;
	virtual bool is_dst() = 0;
	virtual bool read_frame(uint8_t* frame_data, size_t* frame_size) = 0;
	virtual bool seek(uint64_t offset) = 0;
};

#endif
